<?php
/*
Plugin Name: Results count
Plugin URI: http://www.mtaylor.co.uk/development/resultscount
Description: When you search in Google, it tells you at the start how many results you have & what page you are on in the results. The Results Count plugin gives the same capabilities to Wordpress.
Version: 0.5
Author: Matthew Taylor
Author URI: http://www.mtaylor.co.uk/
*/

/*
Copyright 2010  Matthew Taylor  (http://www.mtaylor.co.uk/)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

For a copy of the GNU General Public License, see
<http://www.gnu.org/licenses/>.
*/

# Define version number globally
define ('results_count_version', '0.4.2');

### Search results count heading
function wp_searchheader() {

			# Only display results where relevant
		 	if (is_search() || is_date() || is_category() || is_tag() || is_author()) {

		 	# Define global variables
			global $posts_per_page, $paged, $wp_query, $author_name, $author;


				# Calculate number of results, number of pages & current range.
				$numposts = $wp_query->found_posts;

				# Create formatted version of number for displaying
				if (0 < $numposts) $numposts_pretty = number_format($numposts);

				if(empty($paged)) {
					$paged = 1;
				}

				$startpost = ($posts_per_page * $paged) - $posts_per_page + 1;

				if (($startpost + $posts_per_page - 1) >= $numposts) {
					$endpost = $numposts;
				} else {
					$endpost = $startpost + $posts_per_page -1;
				}


				# Add a comment in the html to show where the plugin generated code starts & ends)
				echo '<!-- The following post count code is automatically generated by the Results Count plugin version '.results_count_version.' : http://wordpress.org/extend/plugins/results-count/ -->';

				# Check if there is less than one page of results & alter text to suit
				if ($numposts>$posts_per_page) {

						# Multiple pages of results
						echo '<p>Showing results <b> '.$startpost. '</b> - <b>' .$endpost. '</b> of <b>' .$numposts_pretty. '</b> for ';
					} else {

						# Check if there is only a single result & alter text to suit
						if ($numposts!=1) {

							# Single page - multiple results
							echo '<p>Showing <b>'.$numposts_pretty.'</b> results for ';
						} else {

							# Single result
							echo '<p>Showing <b>'.$numposts_pretty.'</b> result for ';
						}
					}


				# Search results (display search terms).
				if (is_search()){
					$search_terms = get_query_var('search_terms');

					# Alter text if there is more than one search term used.
					if (count($search_terms)!=1) {
						echo 'the search terms: <b>';
					} else {
						echo 'the search term: <b>';
					}


						echo ' <strong>', the_search_query(), '</strong>';

					# Display the search terms used.
					
# Code removed to solve XSS issue					
#					for ($i = 0; $i < count($search_terms); $i++){
#						echo ' <a href="index.php?s=', $search_terms[$i], '" title="search this site for: ', $search_terms[$i], '">', $search_terms[$i], '</a>';
#					}

				}


				# Archive pages by date (display date range info).
				if (is_date()){
					# Check if the date is a day, a month or a whole year.
					if (is_day()) {
						echo ' <b>';
						the_time('l, F jS, Y');
					}
					elseif (is_month()) {
						echo 'the month of <b>';
						the_time('F, Y');
					}
					elseif (is_year) {
						echo 'the year <b>';
						the_time('Y');
					}
				}


				# Archive pages by category (display category name).
				if (is_category()){
					echo 'the category: <b>', single_cat_title();
#					echo 'the category: <b><a href="http://', $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"], '">', single_cat_title(),'</a>';
				}


				# Archive pages by tag (display tag name).
				if (is_tag()){
					echo 'the tag: <b>', single_tag_title();
#					echo 'the tag: <b><a href="http://', $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"], '">', single_tag_title(),'</a>';
				}
				
				
				# Archive pages by author (display author name).
				if (is_author()){		
					if(isset($_GET['author_name'])) :
							$curauth = get_userdatabylogin($author_name);
						else :
							$curauth = get_userdata(intval($author));
						endif;
					echo 'the author: <b>', $curauth->nickname;
#					echo 'the author: <b><a href="http://', $_SERVER["HTTP_HOST"] . $_SERVER["REQUEST_URI"], '">', $curauth->nickname,'</a>';
				}


			# Close html tags.
			echo '</b>.</p>';
      echo '<!-- End of code generated by Results Count -->';

		}
	}
?>